﻿using Avalonia.Controls.ApplicationLifetimes;
using AvaloniaApplication2.Models;
using CommunityToolkit.Mvvm.ComponentModel;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Avalonia;
using Avalonia.Platform.Storage;
using Avalonia.Media.Imaging;
using System.IO;

namespace AvaloniaApplication2.ViewModels
{
   public partial class Page2ViewModel : ViewModelBase
    {
        [ObservableProperty] User editedUser;
        [ObservableProperty] List<Gender> gendersList;
        [ObservableProperty] Bitmap imageUser;
        
        public Page2ViewModel(int id) 
        {
            GendersList = db.Genders.ToList();
            editedUser = db.Users.Include(x=>x.IdGenderNavigation).FirstOrDefault(x=>x.IdUser == id);
            imageUser = EditedUser.Image != null ? new Bitmap(new MemoryStream(editedUser.Image)) : new Bitmap("Assets/заглушка.jpg");
        }
        public DateTimeOffset DateTimeOffset
        {
            get => new DateTimeOffset((DateTime)EditedUser.BirthDate, TimeSpan.Zero);
            set => EditedUser.BirthDate = new DateTime(value.Year, value.Month, value.Day);
        }

        public void GoBack() => MainWindowViewModel.Self.Page = new Page1();

        public void Save() => db.SaveChanges();
        public async Task Image()
        {
            if (Application.Current?.ApplicationLifetime is not IClassicDesktopStyleApplicationLifetime desktop ||
                desktop.MainWindow?.StorageProvider is not { } provider)
                throw new NullReferenceException("Missing StorageProvider instance.");

            //инициализация в явном виде. менее трушный путь
            //IClassicDesktopStyleApplicationLifetime desktop = (IClassicDesktopStyleApplicationLifetime)Application.Current?.ApplicationLifetime;
            // IStorageProvider provider = desktop.MainWindow?.StorageProvider;
            var files = await provider.OpenFilePickerAsync(new FilePickerOpenOptions()
            {
                Title = "Выберите файл с изображением пользователя",
                AllowMultiple = false               
            });
            await using var readStream = await files[0].OpenReadAsync();
            byte[] buffer = new byte[10000000];
            var bytes = readStream.ReadAtLeast(buffer, 1);
            Array.Resize(ref buffer,bytes);
            editedUser.Image = buffer;
            ImageUser = new Bitmap(new MemoryStream(editedUser.Image));
            db.SaveChanges();
        }

     
    }
}
